"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SequencedValidator = void 0;
var VirtualDeviceValidator_1 = require("./VirtualDeviceValidator");
var SequencedValidator = (function (_super) {
    __extends(SequencedValidator, _super);
    function SequencedValidator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SequencedValidator.prototype.executeSequence = function (sequence, result, context) {
        return __awaiter(this, void 0, void 0, function () {
            var virtualDevice, _i, _a, test_1, resultItem, validator, phrases, _b, errors, err_1, newError, parsedError, resultItem, validator, error;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        virtualDevice = this.virtualDevice(sequence);
                        return [4, virtualDevice.waitForSessionToEnd()];
                    case 1:
                        _c.sent();
                        _i = 0, _a = sequence.tests;
                        _c.label = 2;
                    case 2:
                        if (!(_i < _a.length)) return [3, 7];
                        test_1 = _a[_i];
                        _c.label = 3;
                    case 3:
                        _c.trys.push([3, 5, , 6]);
                        resultItem = { test: test_1 };
                        resultItem.status = "running";
                        validator = new VirtualDeviceValidator_1.Validator(resultItem, undefined);
                        this.emit("message", undefined, validator.resultItem, context);
                        phrases = [];
                        if (test_1.expected && test_1.expected.transcript) {
                            if (Array.isArray(test_1.expected.transcript)) {
                                phrases = test_1.expected.transcript;
                            }
                            else if (test_1.expected.transcript) {
                                phrases.push(test_1.expected.transcript);
                            }
                        }
                        _b = resultItem;
                        return [4, virtualDevice.message(test_1.input, false, phrases, test_1.sequenceIndex === 1)];
                    case 4:
                        _b.actual = _c.sent();
                        errors = validator.check();
                        validator.resultItem.errors = errors;
                        if (validator.resultItem && errors.length === 0) {
                            validator.resultItem.result = "success";
                        }
                        else {
                            validator.resultItem.result = "failure";
                        }
                        validator.resultItem.status = "done";
                        result.tests.push(validator.resultItem);
                        this.emit("result", undefined, validator.resultItem, context);
                        return [3, 6];
                    case 5:
                        err_1 = _c.sent();
                        newError = err_1 instanceof Error ? err_1 : undefined;
                        if (!newError) {
                            parsedError = this.parseError(err_1);
                            if (parsedError && parsedError.results) {
                                newError = new Error(parsedError.results);
                            }
                            else {
                                newError = new Error(this.getError(err_1));
                            }
                        }
                        resultItem = { test: test_1 };
                        validator = new VirtualDeviceValidator_1.Validator(resultItem, newError);
                        validator.resultItem.result = "failure";
                        validator.resultItem.status = "done";
                        error = new VirtualDeviceValidator_1.ValidatorError(test_1.input, undefined, undefined, "SystemError: " + newError.message);
                        validator.resultItem.errors = [error];
                        result.tests.push(validator.resultItem);
                        this.emit("result", undefined, validator.resultItem, context);
                        return [3, 6];
                    case 6:
                        _i++;
                        return [3, 2];
                    case 7: return [2];
                }
            });
        });
    };
    return SequencedValidator;
}(VirtualDeviceValidator_1.VirtualDeviceValidator));
exports.SequencedValidator = SequencedValidator;
//# sourceMappingURL=SequencedValidator.js.map