import { IVirtualDeviceTestSequence, IVirtualDeviceValidatorResult, IVirtualDeviceValidatorResultItem } from "./VirtualDeviceValidator";
export declare type IVirtualDeviceScriptCallback = (error: Error, resultItem: IVirtualDeviceValidatorResultItem, context?: any) => void;
export declare class VirtualDeviceScript {
    private virtualDeviceValidator;
    private findReplaceMap;
    constructor(token?: string, userID?: string, batch?: boolean);
    findReplace(find: string, replace: string): void;
    locale(locale: string): void;
    voiceID(voiceID: string): void;
    tests(scriptContents: string): IVirtualDeviceTestSequence[];
    executeDir(directoryPath: string): Promise<{
        [id: string]: IVirtualDeviceValidatorResult;
    }>;
    executeFile(filePath: string): Promise<IVirtualDeviceValidatorResult>;
    execute(scriptContents: string, context?: any): Promise<IVirtualDeviceValidatorResult>;
    validate(scriptContents: string): undefined | Error;
    prettifyAsPartialHTML(scriptContents: string, partialResultItems: IVirtualDeviceValidatorResultItem[], includeTimeContent?: boolean): string;
    prettifyAsHTML(result: IVirtualDeviceValidatorResult, includeTimeContent?: boolean): string;
    on(event: string, cb: IVirtualDeviceScriptCallback): void;
    off(event: string): void;
    checkAuth(scriptContents: string): Promise<any>;
    private detectInvocationName;
    private tokenize;
}
