export declare class YAMLParser {
    yamlContents: string;
    private static TAB;
    private static NEWLINE;
    private static TWO_SPACES;
    private static countAtStart;
    constructor(yamlContents: string);
    parse(): Value[];
    private parseLine;
}
export declare class YAMLContext {
    lineNumber: number;
    tabs: number;
    stack: any[];
    top(): Value;
    root(): Value;
    popTo(tabs: number): void;
    push(value: Value): void;
}
export declare class Value {
    line: number;
    tabs: number;
    private _name?;
    private _value?;
    static cleanString(s?: string): string | undefined;
    constructor(line: number, tabs: number, _name?: string | undefined, _value?: any);
    name(): string | undefined;
    isArray(): boolean;
    isNull(): boolean;
    isString(): boolean;
    isEmpty(): boolean;
    isObject(): boolean;
    object(): any;
    array(): Value[];
    stringArray(): string[];
    string(): string;
    toString(): string;
    value(v?: any): any;
}
